<script setup lang="ts">
import { onMounted, provide, ref } from 'vue'

import { type Product } from '@/types/Product'
import { type ReceiptItem } from '@/types/ReceiptItem'

import ProductList from '@/components/ProductList.vue'
import MemberAndPromotionCard from './MemberAndPromotionCard.vue'
import ReceiptDetailTable from './ReceiptDetailTable.vue'

import { useReceiptStore } from '@/stores/receipt'
import ReceiptCard from './ReceiptCard.vue'
import ReceiptDialog from './ReceiptDialog.vue'
import CancelDialog from './CancelDialog.vue'
import { usePromotionStore } from '@/stores/Promotion'
const receiptStore = useReceiptStore()
const promotionStore = usePromotionStore()
const products1: Product[] = [
  { id: 1, name: 'คาปูชิโน่', price: 50.0, type: 1 },
  { id: 2, name: 'เอสเปรสโซ่', price: 45.0, type: 1 },
  { id: 3, name: 'ลาเต้ ', price: 50.0, type: 1 },
  { id: 4, name: 'ชาเขียวมัทฉะ', price: 55.0, type: 1 },
  { id: 5, name: 'ชาไทย', price: 50.0, type: 1 },
  { id: 6, name: 'ช็อคโกแลตร้อน', price: 50.0, type: 1 },
  { id: 7, name: 'โกโก้', price: 50.0, type: 1 },
  { id: 8, name: 'คาราเมลมัคคิอาโต้', price: 55.0, type: 1 },
  { id: 9, name: 'นมร้อน', price: 25.0, type: 1 },
  { id: 10, name: 'ชาดำ', price: 35.0, type: 1 },
  { id: 11, name: 'กาแฟส้ม', price: 45.0, type: 1 }
]

const products2: Product[] = [
  { id: 12, name: 'เค้กช็อคโกแลต', price: 35.0, type: 2 },
  { id: 13, name: 'สตอเบอรี่ช็อตเค้ก ', price: 45.0, type: 2 },
  { id: 14, name: 'เค้กชาเขียว', price: 35.0, type: 2 },
  { id: 15, name: 'เค้กกาแฟ ', price: 35.0, type: 2 },
  { id: 16, name: 'เค้กส้ม', price: 40.0, type: 2 },
  { id: 17, name: 'เครปเค้ก', price: 45.0, type: 2 },
  { id: 18, name: 'ชูครีมวนิลานมสด', price: 45.0, type: 2 },
  { id: 19, name: 'ครัวซองค์', price: 30.0, type: 2 }
]

const products3: Product[] = [
  { id: 20, name: 'สปาเก็ตตี้คาโบนาร่า', price: 79.0, type: 3 },
  { id: 21, name: 'สเต๊กไก่ ', price: 89.0, type: 3 },
  { id: 22, name: 'ข้าวซอยไก่', price: 69.0, type: 3 },
  { id: 23, name: 'ข้าวกระเพราหมูสับ ', price: 59.0, type: 3 },
  { id: 24, name: 'ข้าวผัดกุนเชียง', price: 59.0, type: 3 },
  { id: 25, name: 'ผัดซีอิ๊ว หมู', price: 59.0, type: 3 },
  { id: 26, name: 'ต้มยำกุ้ง น้ำข้น', price: 129.0, type: 3 },
  { id: 27, name: 'แกงเขียวหวาน', price: 99.0, type: 3 },
  { id: 28, name: 'ไข่เจียวหมูสับ', price: 59.0, type: 3 },
  { id: 29, name: 'ไข่กระทะ', price: 49.0, type: 3 },
  { id: 30, name: 'ข้าวสวย', price: 20.0, type: 3 }
]

const tab = ref(1)
const selected = (p: Product) => {
  console.log('ProductView ' + p)
  receiptStore.addReceiptItem(p)
  if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
}
const divReceiptItems = ref<HTMLElement | null>(null)
function showrecdialog() {
  receiptStore.showReceiptDialog()
}
function showdeldialog() {
  receiptStore.showDeleteDialog()
}
onMounted(() => {
  promotionStore.getPromotions()
})
</script>

<template>
  <v-container fluid>
    <v-row>
      <!-- Left Col -->
      <v-col cols="12" md="6" style="background-color: rgba(114, 87, 42, 1)">
        <v-sheet
          min-width="300"
          max-width="800"
          min-height="700"
          max-height="1000"
          elevation="6"
          color="rgba(175, 144, 93, 1)"
        >
          <v-tabs v-model="tab" color="yellow" align-tabs="center" bg-color="rgba(75, 56, 42, 1)">
            <v-tab :value="1">Drinks</v-tab>
            <v-tab :value="2">Beverage</v-tab>
            <v-tab :value="3">Foods</v-tab>
          </v-tabs>

          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList :products="products1" @selected-product="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList :products="products2" @selected-product="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList :products="products3" @selected-product="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <!-- Right Col -->
      <v-col cols="12" md="6" style="background-color: rgba(116, 69, 34, 1)">
        <v-container style="padding: 0">
          <v-row dense :gutter="8">
            <!-- Show Order -->
            <v-col cols="12">
              <div ref="divReceiptItems" style="height: 300; overflow: auto">
                <v-sheet min-width="300" max-width="800" height="300" elevation="6">
                  <ReceiptDetailTable />
                </v-sheet>
              </div>
            </v-col>
            <!-- Show Member -->
            <v-col cols="12">
              <v-sheet
                min-width="300"
                max-width="800"
                max-height="300"
                elevation="3"
                color="rgba(114, 87, 42, 1)"
              >
                <MemberAndPromotionCard />
              </v-sheet>
            </v-col>
            <!-- Show Total Amount -->
            <v-col cols="12">
              <ReceiptCard />
            </v-col>
            <!-- Show Button -->
            <v-col cols="12">
              <v-sheet
                min-width="300"
                max-width="800"
                height="80"
                elevation="3"
                class="rounded-sheet"
                color="rgba(180, 143, 81, 1)"
              >
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="x1"
                        height="50px"
                        style="
                          background-color: #ff4949;
                          font-size: x-large;
                          border-color: black;
                          border: 1px solid black;
                        "
                        @click="showdeldialog"
                        >ยกเลิก</v-btn
                      >
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="x1"
                        height="50px"
                        style="
                          background-color: #69ba71;
                          font-size: x-large;
                          border-color: black;
                          border: 1px solid black;
                        "
                        @click="showrecdialog"
                        >ชําระเงิน</v-btn
                      >
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <ReceiptDialog></ReceiptDialog>
  <CancelDialog></CancelDialog>
</template>

<style scoped></style>
